# Config file for the MetviewMiniBundle package
# Defines the following variables:
#
#  MetviewMiniBundle_FEATURES       - list of enabled features
#  MetviewMiniBundle_VERSION        - version of the package
#  MetviewMiniBundle_GIT_SHA1       - Git revision of the package
#  MetviewMiniBundle_GIT_SHA1_SHORT - short Git revision of the package
#


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was project-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/s390x-linux-gnu/cmake/MetviewMiniBundle" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

### computed paths
set_and_check(MetviewMiniBundle_CMAKE_DIR "${PACKAGE_PREFIX_DIR}/lib/s390x-linux-gnu/cmake/MetviewMiniBundle")
set_and_check(MetviewMiniBundle_BASE_DIR "${PACKAGE_PREFIX_DIR}/.")
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEWMINIBUNDLE_CMAKE_DIR ${MetviewMiniBundle_CMAKE_DIR})
  set(METVIEWMINIBUNDLE_BASE_DIR ${MetviewMiniBundle_BASE_DIR})
endif()

### export version info
set(MetviewMiniBundle_VERSION           "5.10.2")
set(MetviewMiniBundle_GIT_SHA1          "")
set(MetviewMiniBundle_GIT_SHA1_SHORT    "")

if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEWMINIBUNDLE_VERSION           "5.10.2" )
  set(METVIEWMINIBUNDLE_GIT_SHA1          "" )
  set(METVIEWMINIBUNDLE_GIT_SHA1_SHORT    "" )
endif()

### has this configuration been exported from a build tree?
set(MetviewMiniBundle_IS_BUILD_DIR_EXPORT OFF)
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEWMINIBUNDLE_IS_BUILD_DIR_EXPORT ${MetviewMiniBundle_IS_BUILD_DIR_EXPORT})
endif()

### insert definitions for IMPORTED targets
if(NOT MetviewMiniBundle_BINARY_DIR)
  find_file(MetviewMiniBundle_TARGETS_FILE
    NAMES MetviewMiniBundle-targets.cmake
    HINTS ${MetviewMiniBundle_CMAKE_DIR}
    NO_DEFAULT_PATH)
  if(MetviewMiniBundle_TARGETS_FILE)
    include(${MetviewMiniBundle_TARGETS_FILE})
  endif()
endif()

### include the <project>-import.cmake file if there is one
if(EXISTS ${MetviewMiniBundle_CMAKE_DIR}/metviewminibundle-import.cmake)
  set(MetviewMiniBundle_IMPORT_FILE "${MetviewMiniBundle_CMAKE_DIR}/metviewminibundle-import.cmake")
  include(${MetviewMiniBundle_IMPORT_FILE})
endif()

### handle third-party dependencies
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEWMINIBUNDLE_LIBRARIES         "")
  set(METVIEWMINIBUNDLE_TPLS              "" )

  include(${CMAKE_CURRENT_LIST_FILE}.tpls OPTIONAL)
endif()

### publish this file as imported
if( DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT )
  set(MetviewMiniBundle_IMPORT_FILE ${CMAKE_CURRENT_LIST_FILE})
  mark_as_advanced(MetviewMiniBundle_IMPORT_FILE)
  set(METVIEWMINIBUNDLE_IMPORT_FILE ${CMAKE_CURRENT_LIST_FILE})
  mark_as_advanced(METVIEWMINIBUNDLE_IMPORT_FILE)
endif()

### export features and check requirements
set(MetviewMiniBundle_FEATURES "TESTS;EXPOSE_SUBPACKAGES;TEST_ASSERTIONS;NETCDF;PNG;PPROC_MIR;PPROC_EMOS;BUFR_TOOLS;ODB;CURL;RPC")
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEWMINIBUNDLE_FEATURES ${MetviewMiniBundle_FEATURES})
endif()
foreach(_f ${MetviewMiniBundle_FEATURES})
  set(MetviewMiniBundle_${_f}_FOUND 1)
  set(MetviewMiniBundle_HAVE_${_f} 1)
  if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
    set(METVIEWMINIBUNDLE_HAVE_${_f} 1)
  endif()
endforeach()
check_required_components(MetviewMiniBundle)
