# Config file for the mars_client package
# Defines the following variables:
#
#  mars_client_FEATURES       - list of enabled features
#  mars_client_VERSION        - version of the package
#  mars_client_GIT_SHA1       - Git revision of the package
#  mars_client_GIT_SHA1_SHORT - short Git revision of the package
#


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was project-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/s390x-linux-gnu/cmake/mars_client" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

### computed paths
set_and_check(mars_client_CMAKE_DIR "${PACKAGE_PREFIX_DIR}/lib/s390x-linux-gnu/cmake/mars_client")
set_and_check(mars_client_BASE_DIR "${PACKAGE_PREFIX_DIR}/.")
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(MARS_CLIENT_CMAKE_DIR ${mars_client_CMAKE_DIR})
  set(MARS_CLIENT_BASE_DIR ${mars_client_BASE_DIR})
endif()

### export version info
set(mars_client_VERSION           "6.29.1")
set(mars_client_GIT_SHA1          "")
set(mars_client_GIT_SHA1_SHORT    "")

if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(MARS_CLIENT_VERSION           "6.29.1" )
  set(MARS_CLIENT_GIT_SHA1          "" )
  set(MARS_CLIENT_GIT_SHA1_SHORT    "" )
endif()

### has this configuration been exported from a build tree?
set(mars_client_IS_BUILD_DIR_EXPORT OFF)
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(MARS_CLIENT_IS_BUILD_DIR_EXPORT ${mars_client_IS_BUILD_DIR_EXPORT})
endif()

### insert definitions for IMPORTED targets
if(NOT mars_client_BINARY_DIR)
  find_file(mars_client_TARGETS_FILE
    NAMES mars_client-targets.cmake
    HINTS ${mars_client_CMAKE_DIR}
    NO_DEFAULT_PATH)
  if(mars_client_TARGETS_FILE)
    include(${mars_client_TARGETS_FILE})
  endif()
endif()

### include the <project>-import.cmake file if there is one
if(EXISTS ${mars_client_CMAKE_DIR}/mars_client-import.cmake)
  set(mars_client_IMPORT_FILE "${mars_client_CMAKE_DIR}/mars_client-import.cmake")
  include(${mars_client_IMPORT_FILE})
endif()

### handle third-party dependencies
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(MARS_CLIENT_LIBRARIES         "")
  set(MARS_CLIENT_TPLS              "" )

  include(${CMAKE_CURRENT_LIST_FILE}.tpls OPTIONAL)
endif()

### publish this file as imported
if( DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT )
  set(mars_client_IMPORT_FILE ${CMAKE_CURRENT_LIST_FILE})
  mark_as_advanced(mars_client_IMPORT_FILE)
  set(MARS_CLIENT_IMPORT_FILE ${CMAKE_CURRENT_LIST_FILE})
  mark_as_advanced(MARS_CLIENT_IMPORT_FILE)
endif()

### export features and check requirements
set(mars_client_FEATURES "TESTS;EXPOSE_SUBPACKAGES;TEST_ASSERTIONS;NETCDF;PNG;PPROC_MIR;PPROC_EMOS;BUFR_TOOLS;ODB;CURL;RPC")
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(MARS_CLIENT_FEATURES ${mars_client_FEATURES})
endif()
foreach(_f ${mars_client_FEATURES})
  set(mars_client_${_f}_FOUND 1)
  set(mars_client_HAVE_${_f} 1)
  if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
    set(MARS_CLIENT_HAVE_${_f} 1)
  endif()
endforeach()
check_required_components(mars_client)
