# Config file for the metview package
# Defines the following variables:
#
#  metview_FEATURES       - list of enabled features
#  metview_VERSION        - version of the package
#  metview_GIT_SHA1       - Git revision of the package
#  metview_GIT_SHA1_SHORT - short Git revision of the package
#


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was project-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/s390x-linux-gnu/cmake/metview" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

### computed paths
set_and_check(metview_CMAKE_DIR "${PACKAGE_PREFIX_DIR}/lib/s390x-linux-gnu/cmake/metview")
set_and_check(metview_BASE_DIR "${PACKAGE_PREFIX_DIR}/.")
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEW_CMAKE_DIR ${metview_CMAKE_DIR})
  set(METVIEW_BASE_DIR ${metview_BASE_DIR})
endif()

### export version info
set(metview_VERSION           "5.10.2")
set(metview_GIT_SHA1          "")
set(metview_GIT_SHA1_SHORT    "")

if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEW_VERSION           "5.10.2" )
  set(METVIEW_GIT_SHA1          "" )
  set(METVIEW_GIT_SHA1_SHORT    "" )
endif()

### has this configuration been exported from a build tree?
set(metview_IS_BUILD_DIR_EXPORT OFF)
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEW_IS_BUILD_DIR_EXPORT ${metview_IS_BUILD_DIR_EXPORT})
endif()

### insert definitions for IMPORTED targets
if(NOT metview_BINARY_DIR)
  find_file(metview_TARGETS_FILE
    NAMES metview-targets.cmake
    HINTS ${metview_CMAKE_DIR}
    NO_DEFAULT_PATH)
  if(metview_TARGETS_FILE)
    include(${metview_TARGETS_FILE})
  endif()
endif()

### include the <project>-import.cmake file if there is one
if(EXISTS ${metview_CMAKE_DIR}/metview-import.cmake)
  set(metview_IMPORT_FILE "${metview_CMAKE_DIR}/metview-import.cmake")
  include(${metview_IMPORT_FILE})
endif()

### handle third-party dependencies
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEW_LIBRARIES         "")
  set(METVIEW_TPLS              "" )

  include(${CMAKE_CURRENT_LIST_FILE}.tpls OPTIONAL)
endif()

### publish this file as imported
if( DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT )
  set(metview_IMPORT_FILE ${CMAKE_CURRENT_LIST_FILE})
  mark_as_advanced(metview_IMPORT_FILE)
  set(METVIEW_IMPORT_FILE ${CMAKE_CURRENT_LIST_FILE})
  mark_as_advanced(METVIEW_IMPORT_FILE)
endif()

### export features and check requirements
set(metview_FEATURES "TESTS;EXPOSE_SUBPACKAGES;TEST_ASSERTIONS;NETCDF;PNG;PPROC_MIR;PPROC_EMOS;BUFR_TOOLS;ODB;CURL;RPC")
if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
  set(METVIEW_FEATURES ${metview_FEATURES})
endif()
foreach(_f ${metview_FEATURES})
  set(metview_${_f}_FOUND 1)
  set(metview_HAVE_${_f} 1)
  if(DEFINED ECBUILD_2_COMPAT AND ECBUILD_2_COMPAT)
    set(METVIEW_HAVE_${_f} 1)
  endif()
endforeach()
check_required_components(metview)
